#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x60TN1x1x8_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=60, 
 * lda=60, ldb=60, ldc=0, mu=1, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (60*(Mb));
   const float *stN = B + (60*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 4, incAn = -(60*(Mb));
   #define incBk 8
   const int incBm = -56, incBn = 60;
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < 7; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += rA0 * rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x60TN60x60x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=60, 
 * lda=60, ldb=60, ldc=0, mu=12, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (60*(Mb));
   const float *stN = B + (60*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*12*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 664, incAn = -(60*(Mb));
   #define incBk 8
   const int incBm = -56, incBn = 60;
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
            for (k=0; k < 7; k++) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[60];
               rA2 = pA0[120];
               rA3 = pA0[180];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[240];
               rA5 = pA0[300];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[360];
               rA7 = pA0[420];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[480];
               rA9 = pA0[540];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[600];
               rA11 = pA0[660];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[61];
               rA2 = pA0[121];
               rA3 = pA0[181];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[241];
               rA5 = pA0[301];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[361];
               rA7 = pA0[421];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[481];
               rA9 = pA0[541];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[601];
               rA11 = pA0[661];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[62];
               rA2 = pA0[122];
               rA3 = pA0[182];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[242];
               rA5 = pA0[302];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[362];
               rA7 = pA0[422];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[482];
               rA9 = pA0[542];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[602];
               rA11 = pA0[662];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[63];
               rA2 = pA0[123];
               rA3 = pA0[183];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[243];
               rA5 = pA0[303];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[363];
               rA7 = pA0[423];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[483];
               rA9 = pA0[543];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[603];
               rA11 = pA0[663];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[64];
               rA2 = pA0[124];
               rA3 = pA0[184];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[244];
               rA5 = pA0[304];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[364];
               rA7 = pA0[424];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[484];
               rA9 = pA0[544];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[604];
               rA11 = pA0[664];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[65];
               rA2 = pA0[125];
               rA3 = pA0[185];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[245];
               rA5 = pA0[305];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[365];
               rA7 = pA0[425];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[485];
               rA9 = pA0[545];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[605];
               rA11 = pA0[665];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[66];
               rA2 = pA0[126];
               rA3 = pA0[186];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[246];
               rA5 = pA0[306];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[366];
               rA7 = pA0[426];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[486];
               rA9 = pA0[546];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[606];
               rA11 = pA0[666];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[67];
               rA2 = pA0[127];
               rA3 = pA0[187];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[247];
               rA5 = pA0[307];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[367];
               rA7 = pA0[427];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[487];
               rA9 = pA0[547];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[607];
               rA11 = pA0[667];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            }
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[60];
            rA2 = pA0[120];
            rA3 = pA0[180];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[240];
            rA5 = pA0[300];
            rC1_0 += rA1 * rB0;
            rA6 = pA0[360];
            rA7 = pA0[420];
            rC2_0 += rA2 * rB0;
            rA8 = pA0[480];
            rA9 = pA0[540];
            rC3_0 += rA3 * rB0;
            rA10 = pA0[600];
            rA11 = pA0[660];
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rC11_0 += rA11 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[61];
            rA2 = pA0[121];
            rA3 = pA0[181];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[241];
            rA5 = pA0[301];
            rC1_0 += rA1 * rB0;
            rA6 = pA0[361];
            rA7 = pA0[421];
            rC2_0 += rA2 * rB0;
            rA8 = pA0[481];
            rA9 = pA0[541];
            rC3_0 += rA3 * rB0;
            rA10 = pA0[601];
            rA11 = pA0[661];
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rC11_0 += rA11 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[62];
            rA2 = pA0[122];
            rA3 = pA0[182];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[242];
            rA5 = pA0[302];
            rC1_0 += rA1 * rB0;
            rA6 = pA0[362];
            rA7 = pA0[422];
            rC2_0 += rA2 * rB0;
            rA8 = pA0[482];
            rA9 = pA0[542];
            rC3_0 += rA3 * rB0;
            rA10 = pA0[602];
            rA11 = pA0[662];
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rC11_0 += rA11 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[63];
            rA2 = pA0[123];
            rA3 = pA0[183];
            rC0_0 += rA0 * rB0;
            rA4 = pA0[243];
            rA5 = pA0[303];
            rC1_0 += rA1 * rB0;
            rA6 = pA0[363];
            rA7 = pA0[423];
            rC2_0 += rA2 * rB0;
            rA8 = pA0[483];
            rA9 = pA0[543];
            rC3_0 += rA3 * rB0;
            rA10 = pA0[603];
            rA11 = pA0[663];
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rC11_0 += rA11 * rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x60TN1x1x8_a1_bX(k, N, 60, alpha, ca + (60*(Mb)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
