#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x64TN1x1x8_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=64, 
 * lda=64, ldb=64, ldc=0, mu=1, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (((Mb) << 6));
   const float *stN = B + (((Nb) << 6));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 0, incAn = -(((Mb) << 6));
   #define incBk 8
   const int incBm = -64, incBn = 64;
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < 8; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x64TN64x64x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=64, 
 * lda=64, ldb=64, ldc=0, mu=12, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/12)*12;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 6));
   const float *stN = B + (((Nb) << 6));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*12*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 704, incAn = -(((Mb) << 6));
   #define incBk 8
   const int incBm = -64, incBn = 64;
   #define incCm 12
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10, rA11;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0, rC11_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            rC11_0 = pC0[11];
            rC11_0 *= rA0;
            for (k=0; k < 8; k++) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[64];
               rA2 = pA0[128];
               rA3 = pA0[192];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[256];
               rA5 = pA0[320];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[384];
               rA7 = pA0[448];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[512];
               rA9 = pA0[576];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[640];
               rA11 = pA0[704];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[65];
               rA2 = pA0[129];
               rA3 = pA0[193];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[257];
               rA5 = pA0[321];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[385];
               rA7 = pA0[449];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[513];
               rA9 = pA0[577];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[641];
               rA11 = pA0[705];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[66];
               rA2 = pA0[130];
               rA3 = pA0[194];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[258];
               rA5 = pA0[322];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[386];
               rA7 = pA0[450];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[514];
               rA9 = pA0[578];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[642];
               rA11 = pA0[706];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[67];
               rA2 = pA0[131];
               rA3 = pA0[195];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[259];
               rA5 = pA0[323];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[387];
               rA7 = pA0[451];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[515];
               rA9 = pA0[579];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[643];
               rA11 = pA0[707];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[68];
               rA2 = pA0[132];
               rA3 = pA0[196];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[260];
               rA5 = pA0[324];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[388];
               rA7 = pA0[452];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[516];
               rA9 = pA0[580];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[644];
               rA11 = pA0[708];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[69];
               rA2 = pA0[133];
               rA3 = pA0[197];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[261];
               rA5 = pA0[325];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[389];
               rA7 = pA0[453];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[517];
               rA9 = pA0[581];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[645];
               rA11 = pA0[709];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[70];
               rA2 = pA0[134];
               rA3 = pA0[198];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[262];
               rA5 = pA0[326];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[390];
               rA7 = pA0[454];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[518];
               rA9 = pA0[582];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[646];
               rA11 = pA0[710];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[71];
               rA2 = pA0[135];
               rA3 = pA0[199];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[263];
               rA5 = pA0[327];
               rC1_0 += rA1 * rB0;
               rA6 = pA0[391];
               rA7 = pA0[455];
               rC2_0 += rA2 * rB0;
               rA8 = pA0[519];
               rA9 = pA0[583];
               rC3_0 += rA3 * rB0;
               rA10 = pA0[647];
               rA11 = pA0[711];
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rC11_0 += rA11 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0[11] = rC11_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x64TN1x1x8_a1_bX(k, N, 64, alpha, ca + (((Mb) << 6)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
