#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x1x1_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 1
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 1
   const int incBm = -(Kb), incBn = (ldb);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < K; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x0TN1x1x24_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)/24)*24, kr = K - Kloop - 2;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 24
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   #define incBk 24
   const int incBm = -(Kb), incBn = (ldb);
   const int incAk0 = ((incAk) / 24), incBk0 = ((incBk) / 24);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   if (K < 3)
   {
      ATL_sJIK0x0x0TN1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

         pA0 += (incAk0);
         pB0 += (incBk0);
         for (k=0; k < Kloop; k += 24) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[23];
            rB0 = pB0[23];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[24];
            rB0 = pB0[24];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            pA0 += (incAk0);
            pB0 += (incBk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            pA0 += (((incAk0) << 1));
            pB0 += (((incBk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            pA0 += (((incAk0) << 1)+incAk0);
            pB0 += (((incBk0) << 1)+incBk0);
            break;
         case 4:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            pA0 += (((incAk0) << 2));
            pB0 += (((incBk0) << 2));
            break;
         case 5:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            pA0 += (((incAk0) << 2)+incAk0);
            pB0 += (((incBk0) << 2)+incBk0);
            break;
         case 6:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            pA0 += (((incAk0) << 2)+((incAk0) << 1));
            pB0 += (((incBk0) << 2)+((incBk0) << 1));
            break;
         case 7:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            pA0 += (7*(incAk0));
            pB0 += (7*(incBk0));
            break;
         case 8:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            pA0 += (((incAk0) << 3));
            pB0 += (((incBk0) << 3));
            break;
         case 9:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            pA0 += (((incAk0) << 3)+incAk0);
            pB0 += (((incBk0) << 3)+incBk0);
            break;
         case 10:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            pA0 += (((incAk0) << 3)+((incAk0) << 1));
            pB0 += (((incBk0) << 3)+((incBk0) << 1));
            break;
         case 11:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            pA0 += (11*(incAk0));
            pB0 += (11*(incBk0));
            break;
         case 12:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            pA0 += (((incAk0) << 3)+((incAk0) << 2));
            pB0 += (((incBk0) << 3)+((incBk0) << 2));
            break;
         case 13:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            pA0 += (13*(incAk0));
            pB0 += (13*(incBk0));
            break;
         case 14:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            pA0 += (14*(incAk0));
            pB0 += (14*(incBk0));
            break;
         case 15:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            pA0 += (15*(incAk0));
            pB0 += (15*(incBk0));
            break;
         case 16:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            pA0 += (((incAk0) << 4));
            pB0 += (((incBk0) << 4));
            break;
         case 17:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            pA0 += (((incAk0) << 4)+incAk0);
            pB0 += (((incBk0) << 4)+incBk0);
            break;
         case 18:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            pA0 += (((incAk0) << 4)+((incAk0) << 1));
            pB0 += (((incBk0) << 4)+((incBk0) << 1));
            break;
         case 19:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            pA0 += (19*(incAk0));
            pB0 += (19*(incBk0));
            break;
         case 20:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            pA0 += (((incAk0) << 4)+((incAk0) << 2));
            pB0 += (((incBk0) << 4)+((incBk0) << 2));
            break;
         case 21:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[21];
            rB0 = pB0[21];
            pA0 += (21*(incAk0));
            pB0 += (21*(incBk0));
            break;
         case 22:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[22];
            rB0 = pB0[22];
            pA0 += (22*(incAk0));
            pB0 += (22*(incBk0));
            break;
         case 23:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[13];
            rB0 = pB0[13];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[15];
            rB0 = pB0[15];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[17];
            rB0 = pB0[17];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[19];
            rB0 = pB0[19];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[20];
            rB0 = pB0[20];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[21];
            rB0 = pB0[21];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[22];
            rB0 = pB0[22];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[23];
            rB0 = pB0[23];
            pA0 += (23*(incAk0));
            pB0 += (23*(incBk0));
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x0TN0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-1)/24)*24, kr = K - Kloop - 1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (lda*Mb);
   const float *stN = B + (ldb*Nb);
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 24
   const int incAm = ((((lda) << 2)) - Kb), incAn = -(Mb*lda);
   #define incBk 24
   const int incBm = -(Kb), incBn = (ldb);
   const int incAk0 = ((incAk) / 24), incBk0 = ((incBk) / 24);
   #define incCm 4
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            m0 = rA0 * rB0;
            rA1 = *pA1;
            rA2 = *pA2;
            m1 = rA1 * rB0;
            rA3 = *pA3;

            for (k=0; k < Kloop; k += 24) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[17];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rA2 = pA2[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[18];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[19];
               rB0 = pB0[19];
               rA1 = pA1[19];
               rA2 = pA2[19];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[19];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[20];
               rB0 = pB0[20];
               rA1 = pA1[20];
               rA2 = pA2[20];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[20];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[21];
               rB0 = pB0[21];
               rA1 = pA1[21];
               rA2 = pA2[21];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[21];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[22];
               rB0 = pB0[22];
               rA1 = pA1[22];
               rA2 = pA2[22];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[22];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[23];
               rB0 = pB0[23];
               rA1 = pA1[23];
               rA2 = pA2[23];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[23];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[24];
               rB0 = pB0[24];
               rA1 = pA1[24];
               rA2 = pA2[24];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[24];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (incAk0);
               pA1 += (incAk0);
               pA2 += (incAk0);
               pA3 += (incAk0);
               pB0 += (incBk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 1));
               pA1 += (((incAk0) << 1));
               pA2 += (((incAk0) << 1));
               pA3 += (((incAk0) << 1));
               pB0 += (((incBk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 1)+incAk0);
               pA1 += (((incAk0) << 1)+incAk0);
               pA2 += (((incAk0) << 1)+incAk0);
               pA3 += (((incAk0) << 1)+incAk0);
               pB0 += (((incBk0) << 1)+incBk0);
               break;
            case 4:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 2));
               pA1 += (((incAk0) << 2));
               pA2 += (((incAk0) << 2));
               pA3 += (((incAk0) << 2));
               pB0 += (((incBk0) << 2));
               break;
            case 5:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 2)+incAk0);
               pA1 += (((incAk0) << 2)+incAk0);
               pA2 += (((incAk0) << 2)+incAk0);
               pA3 += (((incAk0) << 2)+incAk0);
               pB0 += (((incBk0) << 2)+incBk0);
               break;
            case 6:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 2)+((incAk0) << 1));
               pA1 += (((incAk0) << 2)+((incAk0) << 1));
               pA2 += (((incAk0) << 2)+((incAk0) << 1));
               pA3 += (((incAk0) << 2)+((incAk0) << 1));
               pB0 += (((incBk0) << 2)+((incBk0) << 1));
               break;
            case 7:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (7*(incAk0));
               pA1 += (7*(incAk0));
               pA2 += (7*(incAk0));
               pA3 += (7*(incAk0));
               pB0 += (7*(incBk0));
               break;
            case 8:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 3));
               pA1 += (((incAk0) << 3));
               pA2 += (((incAk0) << 3));
               pA3 += (((incAk0) << 3));
               pB0 += (((incBk0) << 3));
               break;
            case 9:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 3)+incAk0);
               pA1 += (((incAk0) << 3)+incAk0);
               pA2 += (((incAk0) << 3)+incAk0);
               pA3 += (((incAk0) << 3)+incAk0);
               pB0 += (((incBk0) << 3)+incBk0);
               break;
            case 10:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 3)+((incAk0) << 1));
               pA1 += (((incAk0) << 3)+((incAk0) << 1));
               pA2 += (((incAk0) << 3)+((incAk0) << 1));
               pA3 += (((incAk0) << 3)+((incAk0) << 1));
               pB0 += (((incBk0) << 3)+((incBk0) << 1));
               break;
            case 11:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (11*(incAk0));
               pA1 += (11*(incAk0));
               pA2 += (11*(incAk0));
               pA3 += (11*(incAk0));
               pB0 += (11*(incBk0));
               break;
            case 12:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 3)+((incAk0) << 2));
               pA1 += (((incAk0) << 3)+((incAk0) << 2));
               pA2 += (((incAk0) << 3)+((incAk0) << 2));
               pA3 += (((incAk0) << 3)+((incAk0) << 2));
               pB0 += (((incBk0) << 3)+((incBk0) << 2));
               break;
            case 13:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (13*(incAk0));
               pA1 += (13*(incAk0));
               pA2 += (13*(incAk0));
               pA3 += (13*(incAk0));
               pB0 += (13*(incBk0));
               break;
            case 14:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (14*(incAk0));
               pA1 += (14*(incAk0));
               pA2 += (14*(incAk0));
               pA3 += (14*(incAk0));
               pB0 += (14*(incBk0));
               break;
            case 15:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (15*(incAk0));
               pA1 += (15*(incAk0));
               pA2 += (15*(incAk0));
               pA3 += (15*(incAk0));
               pB0 += (15*(incBk0));
               break;
            case 16:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 4));
               pA1 += (((incAk0) << 4));
               pA2 += (((incAk0) << 4));
               pA3 += (((incAk0) << 4));
               pB0 += (((incBk0) << 4));
               break;
            case 17:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[17];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 4)+incAk0);
               pA1 += (((incAk0) << 4)+incAk0);
               pA2 += (((incAk0) << 4)+incAk0);
               pA3 += (((incAk0) << 4)+incAk0);
               pB0 += (((incBk0) << 4)+incBk0);
               break;
            case 18:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[17];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rA2 = pA2[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[18];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 4)+((incAk0) << 1));
               pA1 += (((incAk0) << 4)+((incAk0) << 1));
               pA2 += (((incAk0) << 4)+((incAk0) << 1));
               pA3 += (((incAk0) << 4)+((incAk0) << 1));
               pB0 += (((incBk0) << 4)+((incBk0) << 1));
               break;
            case 19:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[17];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rA2 = pA2[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[18];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[19];
               rB0 = pB0[19];
               rA1 = pA1[19];
               rA2 = pA2[19];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[19];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (19*(incAk0));
               pA1 += (19*(incAk0));
               pA2 += (19*(incAk0));
               pA3 += (19*(incAk0));
               pB0 += (19*(incBk0));
               break;
            case 20:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[17];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rA2 = pA2[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[18];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[19];
               rB0 = pB0[19];
               rA1 = pA1[19];
               rA2 = pA2[19];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[19];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[20];
               rB0 = pB0[20];
               rA1 = pA1[20];
               rA2 = pA2[20];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[20];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (((incAk0) << 4)+((incAk0) << 2));
               pA1 += (((incAk0) << 4)+((incAk0) << 2));
               pA2 += (((incAk0) << 4)+((incAk0) << 2));
               pA3 += (((incAk0) << 4)+((incAk0) << 2));
               pB0 += (((incBk0) << 4)+((incBk0) << 2));
               break;
            case 21:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[17];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rA2 = pA2[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[18];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[19];
               rB0 = pB0[19];
               rA1 = pA1[19];
               rA2 = pA2[19];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[19];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[20];
               rB0 = pB0[20];
               rA1 = pA1[20];
               rA2 = pA2[20];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[20];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[21];
               rB0 = pB0[21];
               rA1 = pA1[21];
               rA2 = pA2[21];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[21];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (21*(incAk0));
               pA1 += (21*(incAk0));
               pA2 += (21*(incAk0));
               pA3 += (21*(incAk0));
               pB0 += (21*(incBk0));
               break;
            case 22:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[17];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rA2 = pA2[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[18];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[19];
               rB0 = pB0[19];
               rA1 = pA1[19];
               rA2 = pA2[19];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[19];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[20];
               rB0 = pB0[20];
               rA1 = pA1[20];
               rA2 = pA2[20];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[20];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[21];
               rB0 = pB0[21];
               rA1 = pA1[21];
               rA2 = pA2[21];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[21];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[22];
               rB0 = pB0[22];
               rA1 = pA1[22];
               rA2 = pA2[22];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[22];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (22*(incAk0));
               pA1 += (22*(incAk0));
               pA2 += (22*(incAk0));
               pA3 += (22*(incAk0));
               pB0 += (22*(incBk0));
               break;
            case 23:
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA1[1];
               rA2 = pA2[1];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[1];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rA2 = pA2[2];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[2];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA1[3];
               rA2 = pA2[3];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[3];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rA2 = pA2[4];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[4];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA1[5];
               rA2 = pA2[5];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[5];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rA2 = pA2[6];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[6];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA1[7];
               rA2 = pA2[7];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[7];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rA2 = pA2[8];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[8];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA1[9];
               rA2 = pA2[9];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[9];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rA2 = pA2[10];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[10];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA1[11];
               rA2 = pA2[11];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[11];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rA2 = pA2[12];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[12];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[13];
               rB0 = pB0[13];
               rA1 = pA1[13];
               rA2 = pA2[13];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[13];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rA2 = pA2[14];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[14];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[15];
               rB0 = pB0[15];
               rA1 = pA1[15];
               rA2 = pA2[15];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[15];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rA2 = pA2[16];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[16];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[17];
               rB0 = pB0[17];
               rA1 = pA1[17];
               rA2 = pA2[17];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[17];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rA2 = pA2[18];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[18];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[19];
               rB0 = pB0[19];
               rA1 = pA1[19];
               rA2 = pA2[19];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[19];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[20];
               rB0 = pB0[20];
               rA1 = pA1[20];
               rA2 = pA2[20];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[20];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[21];
               rB0 = pB0[21];
               rA1 = pA1[21];
               rA2 = pA2[21];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[21];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[22];
               rB0 = pB0[22];
               rA1 = pA1[22];
               rA2 = pA2[22];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[22];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rA0 = pA0[23];
               rB0 = pB0[23];
               rA1 = pA1[23];
               rA2 = pA2[23];
               rC2_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA3[23];
               rC3_0 += m1;
               m1 = rA1 * rB0;
               pA0 += (23*(incAk0));
               pA1 += (23*(incAk0));
               pA2 += (23*(incAk0));
               pA3 += (23*(incAk0));
               pB0 += (23*(incBk0));
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA2 * rB0;
            rC1_0 += m1;
            m1 = rA3 * rB0;
            rC2_0 += m0;
            rC3_0 += m1;
            pA0 += incAk0;
            pA1 += incAk0;
            pA2 += incAk0;
            pA3 += incAk0;
            pB0 += incBk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_sJIK0x0x0TN1x1x24_aX_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
